#!/usr/bin/env python
import IndexTest
import IndexTestWRONG

from Numeric import *

def print_array(a):
    for j in range(a.shape[1]):
            for i in  range(a.shape[0]):
                print "[",i,",",j,"] =  ", a[i,j]

def test():
    a = arange(6)
    a = reshape(a, (3,2))
    b = a
    print "----------- IndexTest Results -----------"
    print "-                   a                   -"
    print_array(a)
    print "-           Fortran Output              -"
    b = IndexTest.ind2d(a)
    print "-               Results                 -"
    print "-                   a                   -"
    print_array(a)
    print "-                   b                   -"
    print_array(b)
    print "-----------------------------------------"


def testWRONG():
    a = arange(6).astype(Float)
    a = reshape(a, (3,2))
    b = a
    print "----------- IndexTest WRONG Results -----"
    print "-                   a                   -"
    print_array(a)
    print "-           Fortran Output              -"
    # A needs to be transposed to be a proper array
    # for fortran
    a = transpose(a)
    if not IndexTestWRONG.has_column_major_storage(a):
        print "A is not in proper storage!"
        print "Can not pass such an array!"
    IndexTestWRONG.ind2d(a)
    print "-               Results                 -"
    print "-                   a                   -"
    print_array(a)
    print "-                   b                   -"
    print_array(b)
    print "-----------------------------------------"
if __name__ == '__main__':
    test()
    testWRONG()
