/* -*- C -*- */
%module foo;

/* Conversion from *int to output */
%include typemaps.i


%{
#include "foo.h"
%}


%callback("%s_cb")
int bar(int var, int *r, void *args);
int py_bar(int var, int *r, void *args);
%nocallback

typedef struct{
} foo_callback;
%extend foo_callback{
	/* constructor */
	foo_callback(PyObject *c, PyObject *args) {
	     foo_callback *s;
	     s = (foo_callback*) malloc(sizeof(foo_callback));
	     /* Should handle Py_NoMemory here ... */
	     if(s){
		  Py_INCREF(c);
		  s->callback = c;
		  Py_INCREF(args);
		  s->args = args;
	     }
	     return s;
	}
	/* destructor */
	~foo_callback(){
	     Py_DECREF(self->callback);
	     Py_DECREF(self->args);
	     free(self);
	}
	
}

/* 
 * should have a typemap which turns the error flag int to an approbriate 
 * Python exception.
 */
int foo(int (*callback)(int, int*, void *), int var, int *OUTPUT, void *args);
